#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>

  #ifdef __APPLE__
#include <sys/malloc.h>
  #else
#include <malloc.h>
  #endif

#include "conf.h"
//#define RDTSC_ON
#include "time_.h"

#include "transpose.h"

#if 0
int memcheck(unsigned char *in, unsigned n, unsigned char *cpy) { 
  int i;
  for(i = 0; i < n; i++)
    if(in[i] != cpy[i]) {
      printf("ERROR in[%d]=%x, dec[%d]=%x\n", i, in[i], i, cpy[i]);
	  return i+1; 
	}
  return 0;
}

#ifdef LZ4_ON
  #ifdef USE_SSE
unsigned tp4lz4enc(unsigned char *in, unsigned n, unsigned char *out, unsigned esize, unsigned char *tmp) {
  tp4enc(in, n, tmp, esize); 
  return LZ4_compress(tmp, out, n);
}

unsigned tp4lz4dec(unsigned char *in, unsigned n, unsigned char *out, unsigned esize, unsigned char *tmp) {
  unsigned rc; 
  LZ4_decompress_fast((char *)in, (char *)tmp, n); 
  tp4dec(tmp, n, (unsigned char *)out, esize);
  return rc;
}
#endif
#endif
#endif


typedef unsigned short word;
typedef unsigned int   uint;
typedef unsigned char  byte;


uint flen( FILE* f ) {
  fseek( f, 0, SEEK_END );
  uint len = ftell(f);
  fseek( f, 0, SEEK_SET );
  return len;
}

int main( int argc, char** argv ) {

  setmode( fileno(stdin), O_BINARY ); 
  setmode( fileno(stdout), O_BINARY );

  if( argc<4 ) return 1;

  uint l,n,mode = argv[1][0]; 

  n = atoi(&argv[1][1]);
  if( ((int)n)<=0 ) n=4;

  char* fnam = argv[2]; 
  char* gnam = argv[3];

  FILE* f = stdin; 
  if( strcmp(fnam,"-")!=0 ) f = fopen(fnam,"rb"); 
  if( f==0 ) return 2;

  FILE* g = stdout; 
  if( strcmp(gnam,"-")!=0 ) g = fopen(gnam,"wb"); 
  if( g==0 ) return 3;

  uint f_len = 1<<24;

  byte* inp = (byte*)malloc(f_len); if( inp==0 ) return 4;
  byte* out = (byte*)malloc(f_len+4095); if( out==0 ) return 4;

  while(1) {

    l = fread( inp, 1,f_len, f ); if( l==0 ) break;

    switch( mode ) {
    case 'c': tp4enc( inp, l, out, n ); break;
    case 'd': tp4dec( inp, l, out, n ); break;
    case 'C': tpenc( inp, l, out, n ); break;
    case 'D': tpdec( inp, l, out, n ); break;
    }

    fwrite( out, 1,l, g );

  }

  return 0;
}
	

